sysuse auto, clear

* OLS estimation of the relationship between price, weight, length and fuel efficiency
**************************************************************************************

reg price mpg length weight
* F-stat = 12.98, R-squared = 0.33

* Creation of variables in log
foreach var of varlist price length weight mpg{
gen log_`var' = log(`var')
}
*

* OLS estimation of the relationship between log-transformed price, weight, length and fuel efficiency
******************************************************************************************************

reg log_price log_mpg log_length log_weight
* F-stat = 10.76, R-squared = 0.29

* Comparison of the two models
******************************

/* The non-log model as higher R-sqared and F-stat
But fuel efficiency seems to have explanatory power in the lo-form
Let us try some mix between both models */

reg log_price log_mpg length weight
* F-stat = 12.92, R-squared = 0.33

reg price log_mpg length weight
* F-stat = 14.11, R-squared = 0.35

/* Let us select the latter model.
All explanatory variables are found to significantly different from 0.
According to estimates :
	- A 10% increase in fuel efficiency  decreases price by about $365
	- A 1 in. increase in length is associated with a $107 decrease in price
	- A 100 lbs. increase in wieght is associated with a $392  increase in price
All in all, this model only explain about a third of differences in price across cars */

* Adding foregin/domestic origin
********************************

reg price log_mpg length weight foreign
/* R-squared = 0.52, we now explain 50% of price differences
Fuel efficiency turns out to be insignficant once accounting for origin
Cars produced abroad are on average $3463 more expensive than domestic cars */

* Prediction of a price
***********************
/* 	1 kg = 2.20462 lbs.
	1 m = 39.3701 in.
	1 km = 0.621371 mile
	1 L = 0.264172		*/

di "Predicted price = " log(16.6 * (0.621371 / 0.264172 )) * _b[log_mpg] + 785 * 2.20462 * _b[weight] + 3.521 * 39.3701 * _b[length] + 1 * _b[foreign] + _b[_cons]
* Predicted price = $5,465

* Residuals of the model
************************

predict resid, resid

kdensity resid, normal
* Residuals do not look normaly distributed, maybe our model should be improved...
